#!/usr/bin/env python3
# coding: utf-8

"""
 *
 * convertQuaternionToRadian.py
 *
 *  Created on: 2022/10/28
 *      Author: T.Anazawa
 *
 *  Outline: Convert quaternion to euler angles.
 *
"""
import os
import sys
import rospy
import csv
import math
import tf
from geometry_msgs.msg import Vector3
from docutils.parsers.rst.directives import encoding
from docutils.utils.punctuation_chars import delimiters

def euler2quaternion(euler):
    quat = tf.transformations.quaternion_from_euler(euler[0], euler[1], euler[2])
#     roll = euler[0]
#     pitch = euler[1]
#     yaw = euler[2]
#     
#     degree = radian_to_degree(euler)
#     
#     writeCsv(degree)
    
    print(quat)

def degree2radian(roll, pitch, yaw):
    euler = []
    euler.append(roll / 180.0 * math.pi)
    euler.append(pitch / 180.0 * math.pi)
    euler.append(yaw / 180.0 * math.pi)
    
    return euler

def readCsv(filename):
    try:
        with open(filename, "rb") as csv_file:
            # リスト形式
            f = csv.reader(csv_file, delimiter=",", doublequote=True, lineterminator="\r\n", quotechar='"', skipinitialspace=True)
            header = next(f)
            for row in f:
                quaternion = (float(row[11]), float(row[12]), float(row[13]), float(row[14]))
                quaternion_to_euler(quaternion)
                
    except Exception as err:
        print(err)

def writeCsv(euler):
    try:
        filePath = "./euler.csv"
        if not os.path.isfile(filePath):
            hdr = [ "roll", "pitch", "yaw" ]
            with open(filePath, "a") as f:
                writer = csv.writer(f)
                writer.writerow(hdr)
                
        with open(filePath, "a") as f:
            writer = csv.writer(f)
            writer.writerow([ euler[0], euler[1], euler[2] ])
    
    except Exception as err:
        print(err)

if __name__ == '__main__':
    try:
        args = sys.argv
#        roll = args[1]
#        pitch = args[2]
#        yaw = args[3]
#        euler2quaternion(degree2radian(float(roll), float(pitch), float(yaw)))
        filename = args[1]
        print(filename)
        readCsv(filename)
        
    except rospy.ROSInterruptException:
        pass
    
    finally:
        print("finish")
