import cv2
import numpy as np

if __name__ == "__main__":
    filepath = "/home/fsk9001/map/map_lictia_v4.pgm"
    # 出力パス
    output = "/home/fsk9001/map/map_lictia_v4_test.pgm"
    img = cv2.imread(filepath, 0)
    
    # 画像のピクセル数
    height, width = img.shape[:2]
    # ロボット初期位置(0, 0)のピクセル数
    x = 398
    y = 400
    # 1ピクセル当たりの距離
    delta = 0.05
    # 机の位置(6.439, -4.511)
    target_x = 6.439
    target_y = -4.511
    px = int(x + target_x // delta)
    py = int(y + (target_y // delta) * (-1))
    print(px, py)
    # 机のサイズの半分
    half_size = int(0.8 // delta)
    # 対象色(黒: 254)
    target_color = 0
    # 変更色(白: 0)
    change_color = 254
    
    for i in range(py - half_size - 1, py + half_size - 1):
        for j in range(px - half_size - 1, px + half_size - 1):
            color = img[i, j]
            if color == target_color:
                img[i, j] = change_color
    
    cv2.imwrite(output, img)
    show_img = cv2.imread(output, 0)
    cv2.imshow("convert_map", show_img)
    cv2.waitKey(0)
    cv2.destroyAllWindows()