#!/usr/bin/env python
# coding: utf-8

"""
 *
 * test.py
 *
 *  Created on: 2022/05/31
 *      Author: T.Anazawa
 *
 *  Outline: Publish robot's local path topic.
 *
"""
import os
import rospy
from std_msgs.msg import String

def publishString():
    try:
        pub_ = rospy.Publisher("/private/echo", String, queue_size=10)
        msg = String()
        moji = u"hello"
        rate = rospy.Rate(1)
        
        while not rospy.is_shutdown():
            msg = moji           # Set robot's id.
            
            pub_.publish(msg)
            
            rospy.loginfo(msg)

            rate.sleep()
            
    except Exception as err:
        print(err)

def test_proc():
    rospy.init_node('test_proc', anonymous=True)
    
    rospy.loginfo('test_proc node started.')
    
    publishString()
    
    rospy.spin()

if __name__ == '__main__':
    try:
        test_proc()
        
    except rospy.ROSInterruptException:
        pass
    
    finally:
        rospy.loginfo('test_proc node finished.')
