/*
 * tf_broadcaster.cpp
 *
 *  Created on: 2021/07/08
 *      Author: Tsuyoshi Anazawa
 */

#include <ros/ros.h>
#include <tf/transform_broadcaster.h>

int main(int argc, char** argv)
{
	ros::init(argc, argv, "odom_tf_publisher");
	ros::NodeHandle nh_;

	ros::Rate r(100);

	tf::TransformBroadcaster tf_br_;
	static const std::string ODOM_FRAME_ID = "tb3_0/odom";
	static const std::string CHILD_FRAME_ID = "tb3_0/base_footprint";
	double x = -0.986;
	double y = -1.900;
	double th = 1.57;

	while(nh_.ok()){
		geometry_msgs::Quaternion quat_ = tf::createQuaternionMsgFromYaw(th);
		geometry_msgs::TransformStamped tf_;
		tf_.header.stamp = ros::Time::now();
		tf_.header.frame_id = ODOM_FRAME_ID;
		tf_.child_frame_id = CHILD_FRAME_ID;

		tf_.transform.translation.x = x;
		tf_.transform.translation.y = y;
		tf_.transform.translation.z = 0.0;
		tf_.transform.rotation = quat_;
		tf_br_.sendTransform(tf_);

		r.sleep();
	}
}


